diff --git a/base/common/src/com/netscape/cms/servlet/cert/CertResourceService.java b/base/common/src/com/netscape/cms/servlet/cert/CertResourceService.java
index c05d61b1cb0e9641b38f8e1b94fdf2f412bbcdbd..a4ad60c60fe7c1ecdbf777ee3b2af4c5f7ef39e2 100644
--- a/base/common/src/com/netscape/cms/servlet/cert/CertResourceService.java
+++ b/base/common/src/com/netscape/cms/servlet/cert/CertResourceService.java
@@ -18,16 +18,26 @@
 
 package com.netscape.cms.servlet.cert;
 
-
+import java.io.IOException;
 import java.security.cert.CertificateEncodingException;
 
+import netscape.security.x509.RevocationReason;
+import netscape.security.x509.X509CertImpl;
+
+import com.netscape.certsrv.apps.CMS;
 import com.netscape.certsrv.base.EBaseException;
+import com.netscape.certsrv.ca.ICertificateAuthority;
 import com.netscape.certsrv.dbs.EDBRecordNotFoundException;
 import com.netscape.certsrv.dbs.certdb.CertId;
+import com.netscape.certsrv.dbs.certdb.ICertRecord;
+import com.netscape.certsrv.logging.AuditFormat;
+import com.netscape.certsrv.logging.ILogger;
 import com.netscape.cms.servlet.base.BadRequestException;
 import com.netscape.cms.servlet.base.CMSException;
 import com.netscape.cms.servlet.base.CMSResourceService;
 import com.netscape.cms.servlet.cert.model.CertDAO;
+import com.netscape.cms.servlet.cert.model.CertRevokeRequest;
+import com.netscape.cms.servlet.cert.model.CertUnrevokeRequest;
 import com.netscape.cms.servlet.cert.model.CertificateData;
 import com.netscape.cms.servlet.request.model.CertRetrievalRequestData;
 
@@ -35,7 +45,20 @@ import com.netscape.cms.servlet.request.model.CertRetrievalRequestData;
  * @author alee
  *
  */
-public class CertResourceService extends CMSResourceService implements CertResource{
+public class CertResourceService extends CMSResourceService implements CertResource {
+
+    ICertificateAuthority authority;
+
+    public CertResourceService() {
+        authority = (ICertificateAuthority) CMS.getSubsystem("ca");
+    }
+
+    public CertDAO createDAO() {
+        CertDAO dao = new CertDAO();
+        dao.setLocale(getLocale());
+        dao.setUriInfo(uriInfo);
+        return dao;
+    }
 
     private void validateRequest(CertId id) {
 
@@ -46,27 +69,184 @@ public class CertResourceService extends CMSResourceService implements CertResou
     }
 
     @Override
-    public CertificateData retrieveCert(CertId id) {
+    public CertificateData getCert(CertId id) {
 
         validateRequest(id);
 
         CertRetrievalRequestData data = new CertRetrievalRequestData();
         data.setCertId(id);
-        CertDAO dao = new CertDAO();
+        CertDAO dao = createDAO();
 
         CertificateData certData = null;
 
         try {
             certData = dao.getCert(data);
-        }  catch(EDBRecordNotFoundException e) {
+        } catch (EDBRecordNotFoundException e) {
             throw new CertNotFoundException(id);
-        }  catch (EBaseException e) {
+        } catch (EBaseException e) {
             throw new CMSException("Problem returning certificate: " + id);
-        }  catch(CertificateEncodingException e) {
+        } catch (CertificateEncodingException e) {
             throw new CMSException("Problem encoding certificate searched for: " + id);
         }
 
         return certData;
 
     }
+
+    @Override
+    public CertificateData revokeCert(CertId id, CertRevokeRequest request) {
+
+        RevocationProcessor processor = new RevocationProcessor();
+        processor.setStartTime(CMS.getCurrentDate().getTime());
+
+        // TODO: set initiative based on auth info
+        processor.setInitiative(AuditFormat.FROMAGENT);
+
+        processor.setSerialNumber(id);
+        processor.setRequestID(request.getRequestID());
+
+        RevocationReason revReason = request.getReason();
+        processor.setRevocationReason(revReason);
+        processor.setRequestType(revReason == RevocationReason.CERTIFICATE_HOLD
+                ? RevocationProcessor.ON_HOLD : RevocationProcessor.REVOKE);
+        processor.setInvalidityDate(request.getInvalidityDate());
+        processor.setComments(request.getComments());
+
+        processor.setAuthority(authority);
+
+        try {
+            // TODO: get user cert's serial number from auth info
+            // String userSerialNumber = null;
+
+            // TODO: get user cert's subject DN from auth info
+            // String userSubjectDN = null;
+
+            processor.createCRLExtension();
+
+            ICertRecord record = processor.getCertificateRecord(id);
+            X509CertImpl cert = record.getCertificate();
+
+            // we do not want to revoke the CA certificate accidentally
+            if (processor.isSystemCertificate(cert)) {
+                CMS.debug("revokeCert: rejected revocation request for system certificate " + cert.getSerialNumber());
+                throw new EBaseException(CMS.getLogMessage("CMSGW_UNAUTHORIZED"));
+            }
+
+            // TODO: verify user cert is not revoked
+            /*
+            if (userSerialNumber != null
+                    && userSerialNumber.equals(cert.getSerialNumber().toString())
+                    && record.getStatus().equals(ICertRecord.STATUS_REVOKED)) {
+
+                log(ILogger.LL_FAILURE,
+                        CMS.getLogMessage("CA_CERTIFICATE_ALREADY_REVOKED_1",
+                                cert.getSerialNumber().toString(16)));
+
+                throw new EBaseException(CMS.getLogMessage("CMSGW_UNAUTHORIZED"));
+            }
+            */
+
+            // verify target cert is not revoked
+            if (record.getStatus().equals(ICertRecord.STATUS_REVOKED)) {
+
+                throw new EBaseException(CMS.getLogMessage("CA_CERTIFICATE_ALREADY_REVOKED_1",
+                        cert.getSerialNumber().toString(16)));
+            }
+
+            // TODO: verify user cert's subject DN matches the target cert's subject DN
+            /*
+            if (eeSubjectDN != null && !eeSubjectDN.equals(cert.getSubjectDN().toString())) {
+
+                log(ILogger.LL_FAILURE,
+                        "Certificate 0x" + cert.getSerialNumber().toString(16) + " belongs to different subject.");
+
+                throw new EBaseException(CMS.getLogMessage("BASE_PERMISSION_DENIED"));
+            }
+            */
+
+            processor.addCertificateToRevoke(cert);
+            processor.createRevocationRequest();
+
+            processor.auditChangeRequest(ILogger.SUCCESS);
+
+        } catch (EBaseException e) {
+            log(ILogger.LL_FAILURE, "Error " + e);
+            processor.auditChangeRequest(ILogger.FAILURE);
+
+            throw new CMSException(e.getMessage());
+
+        } catch (IOException e) {
+            log(ILogger.LL_FAILURE, CMS.getLogMessage("CMSGW_ERROR_MARKING_CERT_REVOKED_1", e.toString()));
+            processor.auditChangeRequest(ILogger.FAILURE);
+
+            throw new CMSException(CMS.getLogMessage("CMSGW_ERROR_MARKING_CERT_REVOKED"));
+        }
+
+        // change audit processing from "REQUEST" to "REQUEST_PROCESSED"
+        // to distinguish which type of signed audit log message to save
+        // as a failure outcome in case an exception occurs
+
+        try {
+            processor.processRevocationRequest();
+
+            processor.auditChangeRequestProcessed(ILogger.SUCCESS);
+
+        } catch (EBaseException e) {
+            log(ILogger.LL_FAILURE, "Error " + e);
+            processor.auditChangeRequestProcessed(ILogger.FAILURE);
+
+            throw new CMSException(e.getMessage());
+        }
+
+        return getCert(id);
+    }
+
+    @Override
+    public CertificateData unrevokeCert(CertId id, CertUnrevokeRequest request) {
+
+        RevocationProcessor processor = new RevocationProcessor();
+
+        // TODO: set initiative based on auth info
+        processor.setInitiative(AuditFormat.FROMAGENT);
+
+        processor.setSerialNumber(id);
+        processor.setRequestID(request.getRequestID());
+        processor.setRevocationReason(RevocationReason.CERTIFICATE_HOLD);
+        processor.setAuthority(authority);
+
+        try {
+            processor.addSerialNumberToUnrevoke(id.toBigInteger());
+            processor.createUnrevocationRequest();
+
+            processor.auditChangeRequest(ILogger.SUCCESS);
+
+        } catch (EBaseException e) {
+            log(ILogger.LL_FAILURE, "Error " + e);
+            processor.auditChangeRequest(ILogger.FAILURE);
+
+            throw new CMSException(e.getMessage());
+        }
+
+        // change audit processing from "REQUEST" to "REQUEST_PROCESSED"
+        // to distinguish which type of signed audit log message to save
+        // as a failure outcome in case an exception occurs
+
+        try {
+            processor.processUnrevocationRequest();
+
+            processor.auditChangeRequestProcessed(ILogger.SUCCESS);
+
+        } catch (EBaseException e) {
+            log(ILogger.LL_FAILURE, "Error " + e);
+            processor.auditChangeRequestProcessed(ILogger.FAILURE);
+
+            throw new CMSException(e.getMessage());
+        }
+
+        return getCert(id);
+    }
+
+    public void log(int level, String message) {
+        log(ILogger.S_CA, level, message);
+    }
 }
diff --git a/base/common/src/com/netscape/cms/servlet/cert/CertsResourceService.java b/base/common/src/com/netscape/cms/servlet/cert/CertsResourceService.java
index ed503dad4939ccb778a6bf8617bdba9a56c08ced..60daee11ffc79abc4baa02393cbb104fca2bf40c 100644
--- a/base/common/src/com/netscape/cms/servlet/cert/CertsResourceService.java
+++ b/base/common/src/com/netscape/cms/servlet/cert/CertsResourceService.java
@@ -38,6 +38,13 @@ import com.netscape.cmsutil.ldap.LDAPUtil;
  */
 public class CertsResourceService extends CMSResourceService implements CertsResource {
 
+    public CertDAO createDAO() {
+        CertDAO dao = new CertDAO();
+        dao.setLocale(getLocale());
+        dao.setUriInfo(uriInfo);
+        return dao;
+    }
+
     private String createSearchFilter(String status) {
         String filter = "";
 
@@ -70,10 +77,10 @@ public class CertsResourceService extends CMSResourceService implements CertsRes
         String filter = createSearchFilter(status);
         CMS.debug("listKeys: filter is " + filter);
 
-        CertDAO dao = new CertDAO();
+        CertDAO dao = createDAO();
         CertDataInfos infos;
         try {
-            infos = dao.listCerts(filter, maxResults, maxTime, uriInfo);
+            infos = dao.listCerts(filter, maxResults, maxTime);
         } catch (EBaseException e) {
             e.printStackTrace();
             throw new CMSException("Error listing certs in CertsResourceService.listCerts!");
@@ -88,11 +95,11 @@ public class CertsResourceService extends CMSResourceService implements CertsRes
             throw new WebApplicationException(Response.Status.BAD_REQUEST);
         }
         String filter = createSearchFilter(data);
-        CertDAO dao = new CertDAO();
+        CertDAO dao = createDAO();
         CertDataInfos infos;
 
         try {
-            infos = dao.listCerts(filter, maxResults, maxTime, uriInfo);
+            infos = dao.listCerts(filter, maxResults, maxTime);
         } catch (EBaseException e) {
             e.printStackTrace();
             throw new CMSException("Error listing certs in CertsResourceService.listCerts!");
